
/**
 * Title:        JMeter<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Michael Stover<p>
 * Company:      Apache JMeter<p>
 * @author Michael Stover
 * @version 1.0
 */
package org.apache.jmeter.engine;

public class LagDetector extends Thread
{
  public static final long MAX_SLEEP = 500;

  private static final long DIV = 3;

  private long incr = MAX_SLEEP/DIV;
  private long totalLag;
  private int count;
  private boolean running;

  public LagDetector()
  {
  }

  public float getAveLag()
  {
    return (float)((float)totalLag/(float)count);
  }

  public float getLagRatio()
  {
    return ((float)totalLag/(float)count)/incr;
  }

  public void stopRunning()
  {
    running = false;
  }

  public void run()
  {
    running = true;
    long totalTime = 0,time;
    totalLag = 0;
    count = 0;
    while(running)
    {
      time = System.currentTimeMillis();
      try{currentThread().sleep(incr);}catch(Exception e){}
      time = System.currentTimeMillis() - time;
      totalLag += time - incr;
      count++;
    }
  }


}