package org.apache.jmeter.protocol.ftp.sampler;

import java.io.*;
import java.net.*;

/*
 *  Simple FTP client (non-passive transfers don't work yet)
 *  kind of a hack, lots of room for optimizations
 */

public class FtpClient {
  static int port = 21;
  static int dataPort = 4096;
  File f = new File("e:\\");
  OutputStream out;
  BufferedReader in;
  Socket s;
  boolean passive = false;
  public FtpClient() {
  }
  /** connect to server */
  public void connect(String host, String username, String password) throws Exception {
    InetAddress addr = InetAddress.getByName(host);
    s = new Socket(addr, port);
    out = s.getOutputStream();
    InputStreamReader isr = new InputStreamReader(s.getInputStream());
    in = new BufferedReader(isr);
    in.readLine();
    send("USER " + username);
    getResponse();
    send("PASS " + password);
    getResponse();
  }
  /** set passive mode */
  public void setPassive(boolean flag) {
    passive = flag;
  }
  /** get a file from the server */
  public String getResponse() throws IOException {
    StringBuffer response = new StringBuffer();
    response.append(in.readLine());
    //System.out.println("&" + response + "&");
    while (response.charAt(3) == '-') {
      response.append("\n");
      response.append(in.readLine());
      //System.out.println("&" + response + "&");
    }
    return response.toString();
  }
  /** get a file from the server */
  public String get(String file) throws Exception {
    send("SYST");
    getResponse();
    send("PWD");
    getResponse();
    send("TYPE I");
    getResponse();
    String data = "";
    if (!passive) {
      dataPort++;
      int upper = getUpper(dataPort);
      int lower = getLower(dataPort);
      String ip = InetAddress.getLocalHost().getHostAddress().replace('.',',');
      String port = ip + "," + upper + "," + lower;
      System.out.println("port:" + port);
      send("PORT " + port);
      getResponse();
      dataGrabber grab = new dataGrabber(ip, dataPort);
      while (!grab.isPortCreated()) {
      }
      send("RETR " + file);
      String response = in.readLine();
      System.out.println(response);
      System.out.println(dataPort);
      data = "FTP client - File Not Found";
      if (!response.startsWith("5")) {
        while (!grab.isDone()) {
        }
        data = grab.getData();
      }
    } else {
      send("PASV");
      String port = getResponse();
      int start = port.indexOf('(');
      int end = port.indexOf(')');
      port = port.substring(start + 1, end);
      int a = port.indexOf(',');
      int b = port.indexOf(',', a + 1);
      int c = port.indexOf(',', b + 1);
      int d = port.indexOf(',', c + 1);
      int e = port.indexOf(',', d + 1);
      String ip = port.substring(0, a) + "." + port.substring(a + 1, b) + "." + port.substring(b + 1, c) + "." + port.substring(c + 1, d);
      int upper = Integer.parseInt(port.substring(d + 1, e));
      int lower = Integer.parseInt(port.substring(e + 1));
      int dataPort = getPort(upper,lower);
      send("RETR " + file);
      dataGrabber grab = new dataGrabber(ip, dataPort);
      getResponse();
      while (!grab.isDone()) {
      }
      data = grab.getData();
    }
    return data;
  }
  public static int getPort(int upper, int lower) {
    return upper * 256 + lower;
  }
  public static int getUpper(int port) {
    return port / 256;
  }
  public static int getLower(int port) {
    return port % 256;
  }
  /** grabs the data from the dataport */
  public class dataGrabber implements Runnable {
    StringBuffer buffer = new StringBuffer();
    Socket s;
    boolean done = false;
    boolean portCreated = false;
    String host = "";
    int port = 22;
    public dataGrabber(String host, int port) throws Exception {
      this.host = host;
      this.port = port;
      new Thread((Runnable) this).start();
    }
    public boolean isDone() {
      return done;
    }
    public String getData() {
      return buffer.toString();
    }
    public boolean isPortCreated() {
      return portCreated;
    }
    public void run() {
      try{
        if (passive) {
          s = new Socket(host, port);
        } else {
          System.out.println("creating socket on " + port);
          ServerSocket server = new ServerSocket(port);
          System.out.println("accepting...");
          portCreated = true;
          s = server.accept();
          System.out.println("accepted");
        }
      } catch (Exception e) {
      }
      try {
        InputStream dataIn = s.getInputStream();
        int i = 0;
        while ((i = dataIn.read()) != -1) {
          buffer.append((char) i);
        }
        dataIn.close();
        s.close();
      } catch (Exception e) {
        System.out.println("FTP client: dataGrabber - " + e.toString());
      }
      done = true;
    }
  }
  /** disconnect from the server */
  public void disconnect() {
    try {
      send("QUIT");
      getResponse();
    } catch (Exception e) {
      System.out.println("FTP client - " + e.toString());
    }
    try {
      in.close();
      out.close();
      s.close();
    } catch (Exception e) {
      System.out.println("FTP client - " + e.toString());
    }
  }
  /** send a command to the server */
  public void send(String command) throws IOException {
    //System.out.println("#" + command + "#");
    for (int i = 0; i < command.length(); i++) {
      out.write(command.charAt(i));
    }
    out.write('\r');
    out.write('\n');
    out.flush();
  }
}