
/**
 * Title:        JMeter<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Michael Stover<p>
 * Company:      Apache JMeter<p>
 * @author Michael Stover
 * @version 1.0
 */
package org.apache.jmeter.protocol.http.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import org.apache.jmeter.protocol.http.control.*;

public class SimpleHTTPControllerGUI extends JPanel implements KeyListener
{
  SimpleHTTPController controller;
  JTextField url;

  public SimpleHTTPControllerGUI(SimpleHTTPController c)
  {
    controller = c;
    init();
  }

  /**
   *
   */
  private void init()
  {
    JLabel urlLabel = new JLabel("URL");
    if(controller.getURL() != null && !controller.getURL().equals(""))
      url = new JTextField(controller.getURL());
    else
      url = new JTextField(35);
    url.addKeyListener(this);
    this.setLayout(new FlowLayout(FlowLayout.LEADING));
    this.add(urlLabel);
    this.add(url);
  }

  public void setURL(String url)
  {
    this.url.setText(url);
  }

  public void keyPressed(KeyEvent ke)
  {
  }

  public void keyReleased(KeyEvent ke)
  {
    controller.setURL(url.getText());
  }

  public void keyTyped(KeyEvent ke)
  {
  }
}
