package org.apache.jmeter.threads;

import java.util.*;

import org.apache.jmeter.control.NewSamplerController;
import org.apache.jmeter.timers.Timer;
import org.apache.jmeter.samplers.SampleListener;

/**
 * Title:        Apache JMeter
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Apache Foundation
 * @author Michael Stover
 * @version 1.0
 */

public class ThreadGroup {

	NewSamplerController control;
	Set listeners = new HashSet();
	int numThreads;
	Timer timer;

	public ThreadGroup() {
	}

	public void setSamplerController(NewSamplerController control)
	{
		this.control = control;
	}

	public NewSamplerController getSamplerController()
	{
		return this.control;
	}

	public void setNumThreads(int numThreads)
	{
		this.numThreads = numThreads;
	}

	public int getNumThreads()
	{
		return this.numThreads;
	}

	public void setTimer(Timer timer)
	{
		this.timer = timer;
	}

	public Timer getTimer()
	{
		return this.timer;
	}

	public void addListener(SampleListener listener)
	{
		this.listeners.add(listener);
	}

	public Set getListeners()
	{
		return this.listeners;
	}

	public void removeListener(SampleListener listener)
	{
		this.listeners.remove(listener);
	}
}